<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Unit Conversion and Dimensional Analysis Library: units::math Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Unit Conversion and Dimensional Analysis Library
   &#160;<span id="projectnumber">2.3.0</span>
   </div>
   <div id="projectbrief">A compile-time c++14 unit conversion library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespaceunits.html">units</a></li><li class="navelem"><a class="el" href="namespaceunits_1_1math.html">math</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">units::math Namespace Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>namespace for unit-enabled versions of the <code>&lt;cmath&gt;</code> library  
<a href="namespaceunits_1_1math.html#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a8bc48cef3fdfae35910a4bbe5011abcd"><td class="memTemplParams" colspan="2">template&lt;int power, class UnitType , class  = typename std::enable_if&lt;traits::has_linear_scale&lt;UnitType&gt;::value, int&gt;&gt; </td></tr>
<tr class="memitem:a8bc48cef3fdfae35910a4bbe5011abcd"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceunits_1_1math.html#a8bc48cef3fdfae35910a4bbe5011abcd">pow</a> (const UnitType &amp;value) noexcept -&gt; <a class="el" href="classunits_1_1unit__t.html">unit_t</a>&lt; typename units::detail::power_of_unit&lt; power, typename units::traits::unit_t_traits&lt; UnitType &gt;::unit_type &gt;::type, typename units::traits::unit_t_traits&lt; UnitType &gt;::underlying_type, <a class="el" href="structunits_1_1linear__scale.html">linear_scale</a> &gt;</td></tr>
<tr class="memdesc:a8bc48cef3fdfae35910a4bbe5011abcd"><td class="mdescLeft">&#160;</td><td class="mdescRight">computes the value of <em>value</em> raised to the <em>power</em>  <a href="namespaceunits_1_1math.html#a8bc48cef3fdfae35910a4bbe5011abcd">More...</a><br /></td></tr>
<tr class="separator:a8bc48cef3fdfae35910a4bbe5011abcd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75594321e6d2c1f9fb463667c70e08bf"><td class="memTemplParams" colspan="2">template&lt;int power, class UnitType , class  = typename std::enable_if&lt;traits::has_linear_scale&lt;UnitType&gt;::value, int&gt;&gt; </td></tr>
<tr class="memitem:a75594321e6d2c1f9fb463667c70e08bf"><td class="memTemplItemLeft" align="right" valign="top">constexpr auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceunits_1_1math.html#a75594321e6d2c1f9fb463667c70e08bf">cpow</a> (const UnitType &amp;value) noexcept -&gt; <a class="el" href="classunits_1_1unit__t.html">unit_t</a>&lt; typename units::detail::power_of_unit&lt; power, typename units::traits::unit_t_traits&lt; UnitType &gt;::unit_type &gt;::type, typename units::traits::unit_t_traits&lt; UnitType &gt;::underlying_type, <a class="el" href="structunits_1_1linear__scale.html">linear_scale</a> &gt;</td></tr>
<tr class="memdesc:a75594321e6d2c1f9fb463667c70e08bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">computes the value of <em>value</em> raised to the <em>power</em> as a constexpr  <a href="namespaceunits_1_1math.html#a75594321e6d2c1f9fb463667c70e08bf">More...</a><br /></td></tr>
<tr class="separator:a75594321e6d2c1f9fb463667c70e08bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afd3ba8e5dd62673088f97e3b790be3d2"><td class="memTemplParams" colspan="2"><a id="afd3ba8e5dd62673088f97e3b790be3d2"></a>
template&lt;class UnitTypeLhs , class UnitTypeRhs &gt; </td></tr>
<tr class="memitem:afd3ba8e5dd62673088f97e3b790be3d2"><td class="memTemplItemLeft" align="right" valign="top">UnitTypeLhs&#160;</td><td class="memTemplItemRight" valign="bottom"><b>min</b> (const UnitTypeLhs &amp;lhs, const UnitTypeRhs &amp;rhs)</td></tr>
<tr class="separator:afd3ba8e5dd62673088f97e3b790be3d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a32f4065098853f94f60c6ba58cba2604"><td class="memTemplParams" colspan="2"><a id="a32f4065098853f94f60c6ba58cba2604"></a>
template&lt;class UnitTypeLhs , class UnitTypeRhs &gt; </td></tr>
<tr class="memitem:a32f4065098853f94f60c6ba58cba2604"><td class="memTemplItemLeft" align="right" valign="top">UnitTypeLhs&#160;</td><td class="memTemplItemRight" valign="bottom"><b>max</b> (const UnitTypeLhs &amp;lhs, const UnitTypeRhs &amp;rhs)</td></tr>
<tr class="separator:a32f4065098853f94f60c6ba58cba2604"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac2aeac09538ac3f95fff947c12522faa"><td class="memTemplParams" colspan="2">template&lt;class AngleUnit &gt; </td></tr>
<tr class="memitem:gac2aeac09538ac3f95fff947c12522faa"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gac2aeac09538ac3f95fff947c12522faa">cos</a> (const AngleUnit angle) noexcept</td></tr>
<tr class="memdesc:gac2aeac09538ac3f95fff947c12522faa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute cosine.  <a href="group___unit_math.html#gac2aeac09538ac3f95fff947c12522faa">More...</a><br /></td></tr>
<tr class="separator:gac2aeac09538ac3f95fff947c12522faa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf0a50351f8f51550d00e9831b60e1850"><td class="memTemplParams" colspan="2">template&lt;class AngleUnit &gt; </td></tr>
<tr class="memitem:gaf0a50351f8f51550d00e9831b60e1850"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gaf0a50351f8f51550d00e9831b60e1850">sin</a> (const AngleUnit angle) noexcept</td></tr>
<tr class="memdesc:gaf0a50351f8f51550d00e9831b60e1850"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute sine.  <a href="group___unit_math.html#gaf0a50351f8f51550d00e9831b60e1850">More...</a><br /></td></tr>
<tr class="separator:gaf0a50351f8f51550d00e9831b60e1850"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4a0bd68dee584d4b0b12c49bec0706c1"><td class="memTemplParams" colspan="2">template&lt;class AngleUnit &gt; </td></tr>
<tr class="memitem:ga4a0bd68dee584d4b0b12c49bec0706c1"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga4a0bd68dee584d4b0b12c49bec0706c1">tan</a> (const AngleUnit angle) noexcept</td></tr>
<tr class="memdesc:ga4a0bd68dee584d4b0b12c49bec0706c1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute tangent.  <a href="group___unit_math.html#ga4a0bd68dee584d4b0b12c49bec0706c1">More...</a><br /></td></tr>
<tr class="separator:ga4a0bd68dee584d4b0b12c49bec0706c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga83597409663ca3af0892acf87844af49"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:ga83597409663ca3af0892acf87844af49"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">angle::radian_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga83597409663ca3af0892acf87844af49">acos</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:ga83597409663ca3af0892acf87844af49"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute arc cosine.  <a href="group___unit_math.html#ga83597409663ca3af0892acf87844af49">More...</a><br /></td></tr>
<tr class="separator:ga83597409663ca3af0892acf87844af49"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6070806b3322a08af3ee934731ddcc31"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:ga6070806b3322a08af3ee934731ddcc31"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">angle::radian_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga6070806b3322a08af3ee934731ddcc31">asin</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:ga6070806b3322a08af3ee934731ddcc31"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute arc sine.  <a href="group___unit_math.html#ga6070806b3322a08af3ee934731ddcc31">More...</a><br /></td></tr>
<tr class="separator:ga6070806b3322a08af3ee934731ddcc31"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab8c42d9f521a8909fe92caeb674c30bb"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:gab8c42d9f521a8909fe92caeb674c30bb"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">angle::radian_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gab8c42d9f521a8909fe92caeb674c30bb">atan</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:gab8c42d9f521a8909fe92caeb674c30bb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute arc tangent.  <a href="group___unit_math.html#gab8c42d9f521a8909fe92caeb674c30bb">More...</a><br /></td></tr>
<tr class="separator:gab8c42d9f521a8909fe92caeb674c30bb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga845823260245af2abc83d2cf47f6e74b"><td class="memTemplParams" colspan="2">template&lt;class Y , class X &gt; </td></tr>
<tr class="memitem:ga845823260245af2abc83d2cf47f6e74b"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">angle::radian_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga845823260245af2abc83d2cf47f6e74b">atan2</a> (const Y y, const X x) noexcept</td></tr>
<tr class="memdesc:ga845823260245af2abc83d2cf47f6e74b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute arc tangent with two parameters.  <a href="group___unit_math.html#ga845823260245af2abc83d2cf47f6e74b">More...</a><br /></td></tr>
<tr class="separator:ga845823260245af2abc83d2cf47f6e74b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gab0c26f165fe864ceb9f2af667b3cb66d"><td class="memTemplParams" colspan="2">template&lt;class AngleUnit &gt; </td></tr>
<tr class="memitem:gab0c26f165fe864ceb9f2af667b3cb66d"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gab0c26f165fe864ceb9f2af667b3cb66d">cosh</a> (const AngleUnit angle) noexcept</td></tr>
<tr class="memdesc:gab0c26f165fe864ceb9f2af667b3cb66d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute hyperbolic cosine.  <a href="group___unit_math.html#gab0c26f165fe864ceb9f2af667b3cb66d">More...</a><br /></td></tr>
<tr class="separator:gab0c26f165fe864ceb9f2af667b3cb66d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga38584a9aa9ecbcf455f1a75b23fc8495"><td class="memTemplParams" colspan="2">template&lt;class AngleUnit &gt; </td></tr>
<tr class="memitem:ga38584a9aa9ecbcf455f1a75b23fc8495"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga38584a9aa9ecbcf455f1a75b23fc8495">sinh</a> (const AngleUnit angle) noexcept</td></tr>
<tr class="memdesc:ga38584a9aa9ecbcf455f1a75b23fc8495"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute hyperbolic sine.  <a href="group___unit_math.html#ga38584a9aa9ecbcf455f1a75b23fc8495">More...</a><br /></td></tr>
<tr class="separator:ga38584a9aa9ecbcf455f1a75b23fc8495"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaca6a60340c678dcce1c2e4afc52f3c9d"><td class="memTemplParams" colspan="2">template&lt;class AngleUnit &gt; </td></tr>
<tr class="memitem:gaca6a60340c678dcce1c2e4afc52f3c9d"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gaca6a60340c678dcce1c2e4afc52f3c9d">tanh</a> (const AngleUnit angle) noexcept</td></tr>
<tr class="memdesc:gaca6a60340c678dcce1c2e4afc52f3c9d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute hyperbolic tangent.  <a href="group___unit_math.html#gaca6a60340c678dcce1c2e4afc52f3c9d">More...</a><br /></td></tr>
<tr class="separator:gaca6a60340c678dcce1c2e4afc52f3c9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga29860e26570c2decc2bb8710c1ae911c"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:ga29860e26570c2decc2bb8710c1ae911c"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">angle::radian_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga29860e26570c2decc2bb8710c1ae911c">acosh</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:ga29860e26570c2decc2bb8710c1ae911c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute arc hyperbolic cosine.  <a href="group___unit_math.html#ga29860e26570c2decc2bb8710c1ae911c">More...</a><br /></td></tr>
<tr class="separator:ga29860e26570c2decc2bb8710c1ae911c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaffaf53aeed1529243100d0922bdce834"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:gaffaf53aeed1529243100d0922bdce834"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">angle::radian_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gaffaf53aeed1529243100d0922bdce834">asinh</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:gaffaf53aeed1529243100d0922bdce834"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute arc hyperbolic sine.  <a href="group___unit_math.html#gaffaf53aeed1529243100d0922bdce834">More...</a><br /></td></tr>
<tr class="separator:gaffaf53aeed1529243100d0922bdce834"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8262877321f58e73f76a90e1317e1608"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:ga8262877321f58e73f76a90e1317e1608"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">angle::radian_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga8262877321f58e73f76a90e1317e1608">atanh</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:ga8262877321f58e73f76a90e1317e1608"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute arc hyperbolic tangent.  <a href="group___unit_math.html#ga8262877321f58e73f76a90e1317e1608">More...</a><br /></td></tr>
<tr class="separator:ga8262877321f58e73f76a90e1317e1608"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga37ffdd257c05eb6916d62bfbbc0890e2"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:ga37ffdd257c05eb6916d62bfbbc0890e2"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga37ffdd257c05eb6916d62bfbbc0890e2">exp</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:ga37ffdd257c05eb6916d62bfbbc0890e2"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute exponential function.  <a href="group___unit_math.html#ga37ffdd257c05eb6916d62bfbbc0890e2">More...</a><br /></td></tr>
<tr class="separator:ga37ffdd257c05eb6916d62bfbbc0890e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaed3e6783dc5ab1dda006913aa53f17c8"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:gaed3e6783dc5ab1dda006913aa53f17c8"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gaed3e6783dc5ab1dda006913aa53f17c8">log</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:gaed3e6783dc5ab1dda006913aa53f17c8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute natural logarithm.  <a href="group___unit_math.html#gaed3e6783dc5ab1dda006913aa53f17c8">More...</a><br /></td></tr>
<tr class="separator:gaed3e6783dc5ab1dda006913aa53f17c8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaf02e920d1b57574f1c8ae3974d1e3c80"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:gaf02e920d1b57574f1c8ae3974d1e3c80"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gaf02e920d1b57574f1c8ae3974d1e3c80">log10</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:gaf02e920d1b57574f1c8ae3974d1e3c80"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute common logarithm.  <a href="group___unit_math.html#gaf02e920d1b57574f1c8ae3974d1e3c80">More...</a><br /></td></tr>
<tr class="separator:gaf02e920d1b57574f1c8ae3974d1e3c80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga84d1ea9cad48f0b77cf892633240e4a6"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:ga84d1ea9cad48f0b77cf892633240e4a6"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga84d1ea9cad48f0b77cf892633240e4a6">modf</a> (const ScalarUnit x, ScalarUnit *intpart) noexcept</td></tr>
<tr class="memdesc:ga84d1ea9cad48f0b77cf892633240e4a6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Break into fractional and integral parts.  <a href="group___unit_math.html#ga84d1ea9cad48f0b77cf892633240e4a6">More...</a><br /></td></tr>
<tr class="separator:ga84d1ea9cad48f0b77cf892633240e4a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga872856d20626a6b912cc97b63bc95c89"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:ga872856d20626a6b912cc97b63bc95c89"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga872856d20626a6b912cc97b63bc95c89">exp2</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:ga872856d20626a6b912cc97b63bc95c89"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute binary exponential function.  <a href="group___unit_math.html#ga872856d20626a6b912cc97b63bc95c89">More...</a><br /></td></tr>
<tr class="separator:ga872856d20626a6b912cc97b63bc95c89"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9aee32f9e268b7135c66fc1fb887f44a"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:ga9aee32f9e268b7135c66fc1fb887f44a"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga9aee32f9e268b7135c66fc1fb887f44a">expm1</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:ga9aee32f9e268b7135c66fc1fb887f44a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute exponential minus one.  <a href="group___unit_math.html#ga9aee32f9e268b7135c66fc1fb887f44a">More...</a><br /></td></tr>
<tr class="separator:ga9aee32f9e268b7135c66fc1fb887f44a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaef69e3da7b1cf820853dc8bb5043e1e7"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:gaef69e3da7b1cf820853dc8bb5043e1e7"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gaef69e3da7b1cf820853dc8bb5043e1e7">log1p</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:gaef69e3da7b1cf820853dc8bb5043e1e7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute logarithm plus one.  <a href="group___unit_math.html#gaef69e3da7b1cf820853dc8bb5043e1e7">More...</a><br /></td></tr>
<tr class="separator:gaef69e3da7b1cf820853dc8bb5043e1e7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac19a3f10ebced4d7760193130ed220fa"><td class="memTemplParams" colspan="2">template&lt;class ScalarUnit &gt; </td></tr>
<tr class="memitem:gac19a3f10ebced4d7760193130ed220fa"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classunits_1_1unit__t.html">dimensionless::scalar_t</a>&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gac19a3f10ebced4d7760193130ed220fa">log2</a> (const ScalarUnit x) noexcept</td></tr>
<tr class="memdesc:gac19a3f10ebced4d7760193130ed220fa"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute binary logarithm.  <a href="group___unit_math.html#gac19a3f10ebced4d7760193130ed220fa">More...</a><br /></td></tr>
<tr class="separator:gac19a3f10ebced4d7760193130ed220fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae52f60a9e2a9e7ad1018a846bcf49140"><td class="memTemplParams" colspan="2">template&lt;class UnitType , std::enable_if_t&lt; units::traits::has_linear_scale&lt; UnitType &gt;::value, int &gt;  = 0&gt; </td></tr>
<tr class="memitem:gae52f60a9e2a9e7ad1018a846bcf49140"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gae52f60a9e2a9e7ad1018a846bcf49140">sqrt</a> (const UnitType &amp;value) noexcept -&gt; <a class="el" href="classunits_1_1unit__t.html">unit_t</a>&lt; <a class="el" href="group___unit_manipulators.html#gad6fb385c468a9f9956d23ebc7c38523a">square_root</a>&lt; typename units::traits::unit_t_traits&lt; UnitType &gt;::unit_type &gt;, typename units::traits::unit_t_traits&lt; UnitType &gt;::underlying_type, <a class="el" href="structunits_1_1linear__scale.html">linear_scale</a> &gt;</td></tr>
<tr class="memdesc:gae52f60a9e2a9e7ad1018a846bcf49140"><td class="mdescLeft">&#160;</td><td class="mdescRight">computes the square root of <em>value</em>  <a href="group___unit_math.html#gae52f60a9e2a9e7ad1018a846bcf49140">More...</a><br /></td></tr>
<tr class="separator:gae52f60a9e2a9e7ad1018a846bcf49140"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3162ba1ab8f84bcd2d17cbe60769b851"><td class="memTemplParams" colspan="2">template&lt;class UnitTypeLhs , class UnitTypeRhs , std::enable_if_t&lt; units::traits::has_linear_scale&lt; UnitTypeLhs, UnitTypeRhs &gt;::value, int &gt;  = 0&gt; </td></tr>
<tr class="memitem:ga3162ba1ab8f84bcd2d17cbe60769b851"><td class="memTemplItemLeft" align="right" valign="top">UnitTypeLhs&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga3162ba1ab8f84bcd2d17cbe60769b851">hypot</a> (const UnitTypeLhs &amp;x, const UnitTypeRhs &amp;y)</td></tr>
<tr class="memdesc:ga3162ba1ab8f84bcd2d17cbe60769b851"><td class="mdescLeft">&#160;</td><td class="mdescRight">Computes the square root of the sum-of-squares of x and y.  <a href="group___unit_math.html#ga3162ba1ab8f84bcd2d17cbe60769b851">More...</a><br /></td></tr>
<tr class="separator:ga3162ba1ab8f84bcd2d17cbe60769b851"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gafeea9aa149ff1d941ed830ec389bf7f4"><td class="memTemplParams" colspan="2">template&lt;class UnitType , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitType&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:gafeea9aa149ff1d941ed830ec389bf7f4"><td class="memTemplItemLeft" align="right" valign="top">UnitType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gafeea9aa149ff1d941ed830ec389bf7f4">ceil</a> (const UnitType x) noexcept</td></tr>
<tr class="memdesc:gafeea9aa149ff1d941ed830ec389bf7f4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Round up value.  <a href="group___unit_math.html#gafeea9aa149ff1d941ed830ec389bf7f4">More...</a><br /></td></tr>
<tr class="separator:gafeea9aa149ff1d941ed830ec389bf7f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad7fa514c186141cb9d3fcf824fd41a37"><td class="memTemplParams" colspan="2">template&lt;class UnitType , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitType&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:gad7fa514c186141cb9d3fcf824fd41a37"><td class="memTemplItemLeft" align="right" valign="top">UnitType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gad7fa514c186141cb9d3fcf824fd41a37">floor</a> (const UnitType x) noexcept</td></tr>
<tr class="memdesc:gad7fa514c186141cb9d3fcf824fd41a37"><td class="mdescLeft">&#160;</td><td class="mdescRight">Round down value.  <a href="group___unit_math.html#gad7fa514c186141cb9d3fcf824fd41a37">More...</a><br /></td></tr>
<tr class="separator:gad7fa514c186141cb9d3fcf824fd41a37"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga50270995c6f9ca902fcdc2daf8edc784"><td class="memTemplParams" colspan="2">template&lt;class UnitTypeLhs , class UnitTypeRhs , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitTypeLhs&gt;::value &amp;&amp; traits::is_unit_t&lt;UnitTypeRhs&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:ga50270995c6f9ca902fcdc2daf8edc784"><td class="memTemplItemLeft" align="right" valign="top">UnitTypeLhs&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga50270995c6f9ca902fcdc2daf8edc784">fmod</a> (const UnitTypeLhs numer, const UnitTypeRhs denom) noexcept</td></tr>
<tr class="memdesc:ga50270995c6f9ca902fcdc2daf8edc784"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute remainder of division.  <a href="group___unit_math.html#ga50270995c6f9ca902fcdc2daf8edc784">More...</a><br /></td></tr>
<tr class="separator:ga50270995c6f9ca902fcdc2daf8edc784"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae0019fd57476802def84991c48fe8e66"><td class="memTemplParams" colspan="2">template&lt;class UnitType , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitType&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:gae0019fd57476802def84991c48fe8e66"><td class="memTemplItemLeft" align="right" valign="top">UnitType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gae0019fd57476802def84991c48fe8e66">trunc</a> (const UnitType x) noexcept</td></tr>
<tr class="memdesc:gae0019fd57476802def84991c48fe8e66"><td class="mdescLeft">&#160;</td><td class="mdescRight">Truncate value.  <a href="group___unit_math.html#gae0019fd57476802def84991c48fe8e66">More...</a><br /></td></tr>
<tr class="separator:gae0019fd57476802def84991c48fe8e66"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3e417de9376e1fc58cd07a8465c7e9c6"><td class="memTemplParams" colspan="2">template&lt;class UnitType , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitType&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:ga3e417de9376e1fc58cd07a8465c7e9c6"><td class="memTemplItemLeft" align="right" valign="top">UnitType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga3e417de9376e1fc58cd07a8465c7e9c6">round</a> (const UnitType x) noexcept</td></tr>
<tr class="memdesc:ga3e417de9376e1fc58cd07a8465c7e9c6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Round to nearest.  <a href="group___unit_math.html#ga3e417de9376e1fc58cd07a8465c7e9c6">More...</a><br /></td></tr>
<tr class="separator:ga3e417de9376e1fc58cd07a8465c7e9c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gade1a8bde53a3516371efc5b0bf026e1d"><td class="memTemplParams" colspan="2">template&lt;class UnitTypeLhs , class UnitTypeRhs , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitTypeLhs&gt;::value &amp;&amp; traits::is_unit_t&lt;UnitTypeRhs&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:gade1a8bde53a3516371efc5b0bf026e1d"><td class="memTemplItemLeft" align="right" valign="top">UnitTypeLhs&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gade1a8bde53a3516371efc5b0bf026e1d">copysign</a> (const UnitTypeLhs x, const UnitTypeRhs y) noexcept</td></tr>
<tr class="memdesc:gade1a8bde53a3516371efc5b0bf026e1d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy sign.  <a href="group___unit_math.html#gade1a8bde53a3516371efc5b0bf026e1d">More...</a><br /></td></tr>
<tr class="separator:gade1a8bde53a3516371efc5b0bf026e1d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a22e6b97c78c031cd6966ccdaffffa32b"><td class="memTemplParams" colspan="2"><a id="a22e6b97c78c031cd6966ccdaffffa32b"></a>
template&lt;class UnitTypeLhs , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitTypeLhs&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:a22e6b97c78c031cd6966ccdaffffa32b"><td class="memTemplItemLeft" align="right" valign="top">UnitTypeLhs&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespaceunits_1_1math.html#a22e6b97c78c031cd6966ccdaffffa32b">copysign</a> (const UnitTypeLhs x, const double y) noexcept</td></tr>
<tr class="memdesc:a22e6b97c78c031cd6966ccdaffffa32b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Overload to copy the sign from a raw double. <br /></td></tr>
<tr class="separator:a22e6b97c78c031cd6966ccdaffffa32b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga75fe15cca375d6f73fd1b797d491119d"><td class="memTemplParams" colspan="2">template&lt;class UnitTypeLhs , class UnitTypeRhs , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitTypeLhs&gt;::value &amp;&amp; traits::is_unit_t&lt;UnitTypeRhs&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:ga75fe15cca375d6f73fd1b797d491119d"><td class="memTemplItemLeft" align="right" valign="top">UnitTypeLhs&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga75fe15cca375d6f73fd1b797d491119d">fdim</a> (const UnitTypeLhs x, const UnitTypeRhs y) noexcept</td></tr>
<tr class="memdesc:ga75fe15cca375d6f73fd1b797d491119d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Positive difference.  <a href="group___unit_math.html#ga75fe15cca375d6f73fd1b797d491119d">More...</a><br /></td></tr>
<tr class="separator:ga75fe15cca375d6f73fd1b797d491119d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga133b8c692d6dbf2d19f27adb13ce6ecf"><td class="memTemplParams" colspan="2">template&lt;class UnitTypeLhs , class UnitTypeRhs , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitTypeLhs&gt;::value &amp;&amp; traits::is_unit_t&lt;UnitTypeRhs&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:ga133b8c692d6dbf2d19f27adb13ce6ecf"><td class="memTemplItemLeft" align="right" valign="top">UnitTypeLhs&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga133b8c692d6dbf2d19f27adb13ce6ecf">fmax</a> (const UnitTypeLhs x, const UnitTypeRhs y) noexcept</td></tr>
<tr class="memdesc:ga133b8c692d6dbf2d19f27adb13ce6ecf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Maximum value.  <a href="group___unit_math.html#ga133b8c692d6dbf2d19f27adb13ce6ecf">More...</a><br /></td></tr>
<tr class="separator:ga133b8c692d6dbf2d19f27adb13ce6ecf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2c7353469775440d04f98655e3a9e065"><td class="memTemplParams" colspan="2">template&lt;class UnitTypeLhs , class UnitTypeRhs , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitTypeLhs&gt;::value &amp;&amp; traits::is_unit_t&lt;UnitTypeRhs&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:ga2c7353469775440d04f98655e3a9e065"><td class="memTemplItemLeft" align="right" valign="top">UnitTypeLhs&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga2c7353469775440d04f98655e3a9e065">fmin</a> (const UnitTypeLhs x, const UnitTypeRhs y) noexcept</td></tr>
<tr class="memdesc:ga2c7353469775440d04f98655e3a9e065"><td class="mdescLeft">&#160;</td><td class="mdescRight">Minimum value.  <a href="group___unit_math.html#ga2c7353469775440d04f98655e3a9e065">More...</a><br /></td></tr>
<tr class="separator:ga2c7353469775440d04f98655e3a9e065"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaae0bd34663a2828665567af99a97fb24"><td class="memTemplParams" colspan="2">template&lt;class UnitType , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitType&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:gaae0bd34663a2828665567af99a97fb24"><td class="memTemplItemLeft" align="right" valign="top">UnitType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#gaae0bd34663a2828665567af99a97fb24">fabs</a> (const UnitType x) noexcept</td></tr>
<tr class="memdesc:gaae0bd34663a2828665567af99a97fb24"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute absolute value.  <a href="group___unit_math.html#gaae0bd34663a2828665567af99a97fb24">More...</a><br /></td></tr>
<tr class="separator:gaae0bd34663a2828665567af99a97fb24"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1dd8baba0276c51feeb892983d41ef47"><td class="memTemplParams" colspan="2">template&lt;class UnitType , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitType&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:ga1dd8baba0276c51feeb892983d41ef47"><td class="memTemplItemLeft" align="right" valign="top">UnitType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga1dd8baba0276c51feeb892983d41ef47">abs</a> (const UnitType x) noexcept</td></tr>
<tr class="memdesc:ga1dd8baba0276c51feeb892983d41ef47"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute absolute value.  <a href="group___unit_math.html#ga1dd8baba0276c51feeb892983d41ef47">More...</a><br /></td></tr>
<tr class="separator:ga1dd8baba0276c51feeb892983d41ef47"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga738302bf7a7758eac487800e6ca84316"><td class="memTemplParams" colspan="2">template&lt;class UnitTypeLhs , class UnitMultiply , class UnitAdd , class  = std::enable_if_t&lt;traits::is_unit_t&lt;UnitTypeLhs&gt;::value &amp;&amp; traits::is_unit_t&lt;UnitMultiply&gt;::value &amp;&amp; traits::is_unit_t&lt;UnitAdd&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:ga738302bf7a7758eac487800e6ca84316"><td class="memTemplItemLeft" align="right" valign="top">auto&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___unit_math.html#ga738302bf7a7758eac487800e6ca84316">fma</a> (const UnitTypeLhs x, const UnitMultiply y, const UnitAdd z) noexcept -&gt; decltype(x *y)</td></tr>
<tr class="memdesc:ga738302bf7a7758eac487800e6ca84316"><td class="mdescLeft">&#160;</td><td class="mdescRight">Multiply-add.  <a href="group___unit_math.html#ga738302bf7a7758eac487800e6ca84316">More...</a><br /></td></tr>
<tr class="separator:ga738302bf7a7758eac487800e6ca84316"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>namespace for unit-enabled versions of the <code>&lt;cmath&gt;</code> library </p>
<p>Includes trigonometric functions, exponential/log functions, rounding functions, etc. </p><dl class="section see"><dt>See also</dt><dd>See <code><a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a></code> for more information on <a class="el" href="structunits_1_1unit.html" title="Type representing an arbitrary unit.">unit</a> type containers. </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="a75594321e6d2c1f9fb463667c70e08bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a75594321e6d2c1f9fb463667c70e08bf">&#9670;&nbsp;</a></span>cpow()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;int power, class UnitType , class  = typename std::enable_if&lt;traits::has_linear_scale&lt;UnitType&gt;::value, int&gt;&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr auto units::math::cpow </td>
          <td>(</td>
          <td class="paramtype">const UnitType &amp;&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td> -&gt; <a class="el" href="classunits_1_1unit__t.html">unit_t</a>&lt;typename units::detail::power_of_unit&lt;power, typename units::traits::unit_t_traits&lt;UnitType&gt;::unit_type&gt;::type, typename units::traits::unit_t_traits&lt;UnitType&gt;::underlying_type, <a class="el" href="structunits_1_1linear__scale.html">linear_scale</a>&gt;
		</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">constexpr</span><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>computes the value of <em>value</em> raised to the <em>power</em> as a constexpr </p>
<p>Only implemented for <a class="el" href="structunits_1_1linear__scale.html" title="unit_t scale which is linear">linear_scale</a> units. <em>Power</em> must be known at compile time, so the resulting unit type can be deduced. Additionally, the power must be <em>a positive, integral, value</em>. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">power</td><td>exponential power to raise <em>value</em> by. </td></tr>
  </table>
  </dd>
</dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td><code><a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a></code> derived type to raise to the given <em>power</em> </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>new <a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a>, raised to the given exponent </dd></dl>

</div>
</div>
<a id="a8bc48cef3fdfae35910a4bbe5011abcd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8bc48cef3fdfae35910a4bbe5011abcd">&#9670;&nbsp;</a></span>pow()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;int power, class UnitType , class  = typename std::enable_if&lt;traits::has_linear_scale&lt;UnitType&gt;::value, int&gt;&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">auto units::math::pow </td>
          <td>(</td>
          <td class="paramtype">const UnitType &amp;&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td> -&gt; <a class="el" href="classunits_1_1unit__t.html">unit_t</a>&lt;typename units::detail::power_of_unit&lt;power, typename units::traits::unit_t_traits&lt;UnitType&gt;::unit_type&gt;::type, typename units::traits::unit_t_traits&lt;UnitType&gt;::underlying_type, <a class="el" href="structunits_1_1linear__scale.html">linear_scale</a>&gt;
		</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>computes the value of <em>value</em> raised to the <em>power</em> </p>
<p>Only implemented for <a class="el" href="structunits_1_1linear__scale.html" title="unit_t scale which is linear">linear_scale</a> units. <em>Power</em> must be known at compile time, so the resulting unit type can be deduced. </p><dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">power</td><td>exponential power to raise <em>value</em> by. </td></tr>
  </table>
  </dd>
</dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td><code><a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a></code> derived type to raise to the given <em>power</em> </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>new <a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a>, raised to the given exponent </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Oct 3 2020 11:16:54 for Unit Conversion and Dimensional Analysis Library by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
